---- #########################################################################
---- #                                                                       #
---- # fullspan                     #
---- #                                                                       #
---- #########################################################################


local BitmapsFS = {}
local BitmapsNFS = {}
local options = {
  { "TextColor", COLOR, RED },
  { "Switch_fullspan", SOURCE,110},  -----------switch  moode fullspan  
  { "Invert", VALUE, 1,1,4},
  { "manche_aileron", SOURCE, 200},           ---canal sortie aileron
  { "Invert2", BOOL, 0},
}

local function create(zone, options)
  local wgt  = { zone=zone, options=options}
  return wgt
end

local function update(wgt, options)
  if (wgt==nil) then
    print("update(nil)")
    return
  end
  wgt.options = options
end

local function background(wgt)
  return
end

------------------------------------------------------------

local function getArmedStatus(wgt)
  local FLS = getValue(wgt.options.Switch_fullspan)

 if wgt.options.Invert > 2 then
    FLS = -FLS
  end
 return FLS
end

-- This size is for top bar wgts
local function refreshZoneTiny(wgt)
 
end

--- Size is 160x32 1/8th
local function refreshZoneSmall(wgt)
  local FLS = getArmedStatus(wgt)
  local aileron  = getValue(wgt.options.manche_aileron)
	if wgt.options.Invert2 == 1 then
    aileron = -aileron
	end
    
  if BitmapsFS[0] == nil then
    BitmapsFS[0] = Bitmap.open("/WIDGETS/fullspan/160FSbas.png")
    BitmapsFS[1] = Bitmap.open("/WIDGETS/fullspan/160FSmilieu.png")
	BitmapsFS[2] = Bitmap.open("/WIDGETS/fullspan/160FShaut.png")
	BitmapsNFS[0] = Bitmap.open("/WIDGETS/fullspan/160NFSbas.png")
    BitmapsNFS[1] = Bitmap.open("/WIDGETS/fullspan/160NFSmilieu.png")
	BitmapsNFS[2] = Bitmap.open("/WIDGETS/fullspan/160NFShaut.png")
  end 
 if wgt.options.Invert == 1 or wgt.options.Invert == 3 then
  if FLS > -100 then                                           --- full span activé
		if aileron > 300 then  -----------pos haut
		lcd.drawBitmap(BitmapsFS[2], wgt.zone.x ,wgt.zone.y )
		elseif aileron < -300 then   ------pos bas 
		lcd.drawBitmap(BitmapsFS[0], wgt.zone.x ,wgt.zone.y )
		else                           --- pos milieu
		lcd.drawBitmap(BitmapsFS[1], wgt.zone.x ,wgt.zone.y )
		end
	else                                                        --- fullspan non activé
		if aileron > 300 then  -----------pos haut
		lcd.drawBitmap(BitmapsNFS[2], wgt.zone.x ,wgt.zone.y )
		elseif aileron < -300 then   ------pos bas 
		lcd.drawBitmap(BitmapsNFS[0], wgt.zone.x ,wgt.zone.y )
		else                           --- pos milieu
		lcd.drawBitmap(BitmapsNFS[1], wgt.zone.x ,wgt.zone.y )
		end
 	end
else
 if FLS > 100 then                                           --- full span activé
		if aileron > 300 then  -----------pos haut
		lcd.drawBitmap(BitmapsFS[2], wgt.zone.x ,wgt.zone.y )
		elseif aileron < -300 then   ------pos bas 
		lcd.drawBitmap(BitmapsFS[0], wgt.zone.x ,wgt.zone.y )
		else                           --- pos milieu
		lcd.drawBitmap(BitmapsFS[1], wgt.zone.x ,wgt.zone.y )
		end
	else                                                        --- fullspan non activé
		if aileron > 300 then  -----------pos haut
		lcd.drawBitmap(BitmapsNFS[2], wgt.zone.x ,wgt.zone.y )
		elseif aileron < -300 then   ------pos bas 
		lcd.drawBitmap(BitmapsNFS[0], wgt.zone.x ,wgt.zone.y )
		else                           --- pos milieu
		lcd.drawBitmap(BitmapsNFS[1], wgt.zone.x ,wgt.zone.y )
		end
 	end
end
	--------------------------------------------------------------------
 	local FLS = wgt.options.Switch_fullspan
	local visu = getValue('sh')   -------------------------SH
   
   if visu > 10 then 
	lcd.drawSource(wgt.zone.x +10  ,wgt.zone.y + 45,FLS  ,0 + CUSTOM_COLOR) 
    end
	--------------------------------------------------------------------
	 lcd.setColor(TEXT_COLOR, BLACK) 
end

--- Size is 225x98 1/4th  (no sliders/trim)
local function refreshZoneMedium(wgt)
 
end

--- Size is 192x152 1/2
local function refreshZoneLarge(wgt)

end

--- Size is 390x172 1/1
--- Size is 460x252 1/1 (no sliders/trim/topbar)
local function refreshZoneXLarge(wgt)

end


function refresh(wgt)

  if (wgt==nil) then
    print("refresh(nil)")
    return
  end

  if (wgt.options==nil) then
    print("refresh(wgt.options=nil)")
    return
  end

  lcd.setColor(CUSTOM_COLOR, wgt.options.TextColor)

  if     wgt.zone.w  > 380 and wgt.zone.h > 165 then refreshZoneXLarge(wgt)
  elseif wgt.zone.w  > 180 and wgt.zone.h > 145 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 170 and wgt.zone.h >  65 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 150 and wgt.zone.h >  28 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  >  65 and wgt.zone.h >  35 then refreshZoneTiny(wgt)
  end
   lcd.setColor(TEXT_COLOR, BLACK) 
    lcd.setColor(CUSTOM_COLOR, BLACK)
end

return { name="fullspan", options=options, create=create, update=update, background=background, refresh=refresh }
